<template>
  <div />
</template>

<script>
import { onMounted, onUpdated } from 'vue'
import { Fancybox } from '@fancyapps/ui'

export default {
  name: 'ImageListZoomed',
  emits: ['button'],
  props: {
    images: { type: Array, required: true },
    groupName: { type: String, required: true },
    managing: { type: Boolean, required: true },
    isCurrentUser: { type: Boolean, default: false },
  },
  setup(props, context) {
    const bindFancybox = () => {
      const buttons = ['zoom', 'close']

      if (props.isCurrentUser) {
        buttons.unshift('edit')
      }

      Fancybox.bind(`[data-fancybox="${props.groupName}"]`, {
        Toolbar: {
          display: buttons,
        },
        Hash: false,
      })
    }

    onMounted(() => {
      bindFancybox()
    })

    onUpdated(() => {
      bindFancybox()
    })

    Fancybox.Plugins.Toolbar.defaults.items.edit = {
      type: 'button',
      class: 'fancybox__button--edit',
      label: 'Edit',
      html: '<svg xmlns="http://www.w3.org/2000/svg" width="24" height="24" viewBox="0 0 32 32"><path d="M7.127 22.562l-7.127 1.438 1.438-7.128 5.689 5.69zm1.414-1.414l11.228-11.225-5.69-5.692-11.227 11.227 5.689 5.69zm9.768-21.148l-2.816 2.817 5.691 5.691 2.816-2.819-5.691-5.689z"/></svg>',
      click(e) {
        e.preventDefault()
        const imageId = Fancybox.getInstance()?.getSlide()?.$thumb?.dataset?.imageId
        context.emit('button', 'edit-image', { imageId })
        Fancybox.close()
      },
    }
  },
}
</script>
